"""added file ranking

Revision ID: 8df0654b8992
Revises: 2e6d4f73130a
Create Date: 2024-12-16 15:14:11.771915

"""
from typing import Sequence, Union
from alembic import op
from sqlalchemy import inspect

import sqlalchemy as sa



# revision identifiers, used by Alembic.
revision: str = '8df0654b8992'
down_revision: Union[str, None] = '2e6d4f73130a'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    if not has_column('files', 'ranking'):
        op.add_column('files', sa.Column('ranking', sa.Integer(), nullable=False, server_default="0"))
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('files', 'ranking')
    # ### end Alembic commands ###


def has_column(table_name, column_name):
    bind = op.get_context().bind
    insp = inspect(bind)
    columns = insp.get_columns(table_name)
    return any(c["name"] == column_name for c in columns)